/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CNUN                                                     */
/* Tabela : CONVUNID                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CNUN
BEFORE INSERT OR UPDATE OR DELETE
ON CONVUNID FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCNUN := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.SGUNIDDE,0)   <> NVL(:NEW.SGUNIDDE,0))   OR
         (NVL(:OLD.SGUNIDPARA,0) <> NVL(:NEW.SGUNIDPARA,0)) OR
         (NVL(:OLD.VRFTCONVER,0) <> NVL(:NEW.VRFTCONVER,0)) OR
         (NVL(:OLD.IDTIPOPE,0)   <> NVL(:NEW.IDTIPOPE,0)) THEN
         :NEW.DTULTATUCNUN := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CONVUNID', '', 'SGUNIDDE='||:OLD.SGUNIDDE||';SGUNIDPARA='||:OLD.SGUNIDPARA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CONVUNID MODIFY DTULTATUCNUN DEFAULT SYSDATE
/
